//Export.cpp
#include "export.h"
#include "tinyxml/tinyxml.h"

#include "xmlnode/XmlNode.h"
#include "xmlnode/StringUtil.h"

INT_PTR CALLBACK maxProjectOptionsDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam) ;

//-----------------------------------------------------------------------------------
Export::Export()
{
	m_pXmlRoot = NULL;
	m_bRun = false;
	m_bLeftHand = false;
}
//-----------------------------------------------------------------------------------
Export::~Export()
{

}
//-----------------------------------------------------------------------------------
int Export::ExtCount()
{
	//TODO: Returns the number of file name extensions supported by the plug-in.
	return 1;
}
//-----------------------------------------------------------------------------------
const TCHAR *Export::Ext(int n)
{		
	//TODO: Return the 'i-th' file name extension (i.e. "3DS").
	return _T("xml");
}
//-----------------------------------------------------------------------------------
const TCHAR *Export::LongDesc()
{
	//TODO: Return long ASCII description (i.e. "Targa 2.0 Image File")
	return _T("");
}
//-----------------------------------------------------------------------------------	
const TCHAR *Export::ShortDesc() 
{			
	//TODO: Return short ASCII description (i.e. "Targa")
	return _T("My Format");
}
//-----------------------------------------------------------------------------------
const TCHAR *Export::AuthorName()
{			
	//TODO: Return ASCII Author name
	return _T("");
}
//-----------------------------------------------------------------------------------
const TCHAR *Export::CopyrightMessage() 
{	
	// Return ASCII Copyright message
	return _T("");
}
//-----------------------------------------------------------------------------------
const TCHAR *Export::OtherMessage1() 
{		
	//TODO: Return Other message #1 if any
	return _T("");
}
//-----------------------------------------------------------------------------------
const TCHAR *Export::OtherMessage2() 
{		
	//TODO: Return other message #2 in any
	return _T("");
}
//-----------------------------------------------------------------------------------
unsigned int Export::Version()
{				
	//TODO: Return Version number * 100 (i.e. v3.01 = 301)
	return 100;
}
//-----------------------------------------------------------------------------------
void Export::ShowAbout(HWND hWnd)
{			
	// Optional
}
//-----------------------------------------------------------------------------------
BOOL Export::SupportsOptions(int ext, DWORD options)
{
	// TODO Decide which options to support.  Simply return
	// true for each option supported by each Extension 
	// the exporter supports.

	return TRUE;
}
//-----------------------------------------------------------------------------------
int Export::DoExport(const TCHAR *name, ExpInterface *ei, Interface *i, BOOL suppressPrompts, DWORD options)
{
	//TODO: Implement the actual file Export here and 
	//		return TRUE If the file is exported properly
	if(!suppressPrompts)
	{
		DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_PANEL), GetActiveWindow(), maxProjectOptionsDlgProc, (LPARAM)this);
	}

	if( GetExport() == false )
		return TRUE;

	m_pInterface = i;

	//ͽƮ е 
	int nPrecision = 2;
	sprintf(m_szFmtStr, "%%4.%df", nPrecision);
	
	m_strName = name;
	GetAnimationInfo();
	INode* pRoot = i->GetRootNode();

	//XML 带 .
	BuildINode( pRoot, m_pXmlRoot );

	WriteHeader( m_pXmlRoot );
	ExportXML( m_strName.c_str() );
	
	return TRUE;
}